﻿using System.Runtime.CompilerServices;

namespace ConsoleApp1
{
    class Program
    {
        static void Main(string[] args)
        {
            Thread t = new Thread(gcCheck);
            t.IsBackground = true;
            t.Start();

            GameLoop();
        }

        static Vector _newPos;

        private static void gcCheck()
        {
            long oldValue = 0;

            while (true)
            {
                int gcCount = GC.CollectionCount(0) + GC.CollectionCount(1) + GC.CollectionCount(2);

                long frame = _frame;
                double fps = (frame - oldValue) / 60.0;
                oldValue = frame;
                Console.WriteLine($"{gcCount} {fps:F2}");

                Thread.Sleep(1000);
            }
        }

        static long _frame;

        private static void GameLoop()
        {
            while (true)
            {
                int x = Environment.TickCount % 30;
                int y = Environment.TickCount % 35;
                int z = Environment.TickCount % 60;

                Vector player = new Vector(x, y, z, 1, 2, 3, 4, 5, 6);

                x = Environment.TickCount % 30;
                y = Environment.TickCount % 35;
                z = Environment.TickCount % 60;

                Vector speed = new Vector(x, y, z, 11, 22, 33, 44, 55, 66);

                _newPos = player + speed;

                _frame++;
            }
        }
    }

    readonly struct Vector
    {
        readonly double _x;
        readonly double _y;
        readonly double _z;

        readonly double _x2;
        readonly double _y2;
        readonly double _z2;

        readonly double _x3;
        readonly double _y3;
        readonly double _z3;

        public double X { get { return _x; } }
        public double Y { get { return _y; } }
        public double Z { get { return _z; } }
        public double X2 { get { return _x2; } }
        public double Y2 { get { return _y2; } }
        public double Z2 { get { return _z2; } }
        public double X3 { get { return _x3; } }
        public double Y3 { get { return _y3; } }
        public double Z3 { get { return _z3; } }

        public Vector(double x, double y, double z, double x2, double y2, double z2, double x3, double y3, double z3)
        {
            _x = x;
            _y = y;
            _z = z;

            _x2 = x2;
            _y2 = y2;
            _z2 = z2;

            _x3 = x3;
            _y3 = y3;
            _z3 = z3;
        }

        [MethodImpl(MethodImplOptions.AggressiveInlining)]
        public static Vector operator +(in Vector v1, in Vector v2)
        {
            return new Vector(v1.X + v2.X,
                              v1.Y + v2.Y,
                              v1.Z + v2.Z,

                              v1.X2 + v2.X2,
                              v1.Y2 + v2.Y2,
                              v1.Z2 + v2.Z2,

                              v1.X3 + v2.X3,
                              v1.Y3 + v2.Y3,
                              v1.Z3 + v2.Z3);
        }

        public override string ToString()
        {
            return $"({_x},{_y},{_z})";
        }
    }
}
